
#include "AccountHolder.h"
#include "Bank.h"
#include <iostream>

namespace Example
{
   AccountHolder::AccountHolder(const string& name, const string& address)
   {
      m_fullName = name;
      m_address = address;
      m_bank = NULL;
      m_balance = 0.0;
   }

   AccountHolder::~AccountHolder()
   {
   }

   void AccountHolder::chooseBank(Bank& bank)
   {
      // the Bank needs to know who its customers are
      bank.addNewAccount(*this, m_balance);
      // and we add the Bank to our records
      m_bank = &bank;
   }

   void AccountHolder::receiveStatement(const string& date, float balance)
   {
      cout << m_fullName << ": balance on " << date << " is $" << balance << endl;
      if (balance != m_balance)
      {
         // the Bank's balance is not what our records indicate :(
         cout << "That's not what I expected!" << endl;
      }
      cout << endl;
   }

   void AccountHolder::deposit(float sum)
   {
      // update our own records
      m_balance += sum;
      // and perform the official transaction with the Bank
      m_bank->deposit(*this, sum);
   }

   void AccountHolder::withdraw(float sum)
   {
      // update our own records
      m_balance -= sum;
      // and perform the official transaction with the Bank
      m_bank->withdraw(*this, sum);
   }

   float AccountHolder::getBalance() const
   {      
      return m_balance;
   }
}
