
#include "AuctionHouse.h"
#include "AuctionUser.h"

namespace Example
{
   AuctionHouse::AuctionHouse()
   {
   }

   AuctionHouse::~AuctionHouse()
   {
   }

   void AuctionHouse::addNewUser(AuctionUser& newUser, const string& password)
   {
      m_users.insert(&newUser);
      m_passwords[newUser.getUsername()] = password;
      // send out a confirmation email for this new account
      newUser.receiveEmail("your new account has been created");
   }

   void AuctionHouse::updatePassword(AuctionUser& user, const string& password) 
   {
      m_passwords[user.getUsername()] = password;
      // send out a confirmation email for security purposes
      user.receiveEmail("your password has been changed");
   }

   bool AuctionHouse::login(const string& username, const string& password)
   {
      return ((m_passwords.find(username) != m_passwords.end()) &&
         (m_passwords[username].compare(password) == 0));
   }

   void AuctionHouse::advertise()
   {
      // when we advertise, we send the same email to every user in our database
      for (set<AuctionUser*>::iterator user = m_users.begin(); user != m_users.end(); ++user)
      {
         AuctionUser* u = *user;
         u->receiveEmail("Click on this link and receive 10 SpaceBucks credit on your next purchase!");
      }
   }

}