
#include "Bank.h"

namespace Example
{
   Bank::Bank()
   {
   }

   Bank::~Bank()
   {
   }

   void Bank::addNewAccount(AccountHolder& newCustomer, float openingBalance)
   {
      m_accountBalances[&newCustomer] = openingBalance;
   }

   void Bank::deposit(AccountHolder& customer, float sum)
   {
      m_accountBalances[&customer] += sum;
   }

   void Bank::withdraw(AccountHolder& customer, float sum)
   {
      // we assume they have enough money!
      m_accountBalances[&customer] -= sum;
   }

   void Bank::sendOutStatements(const string& date)
   {
      // send out a statement to all of user AccountHolders
      AccountDatabase::iterator end = m_accountBalances.end();
      for (AccountDatabase::iterator account = m_accountBalances.begin(); account != end; ++account)
      {
         AccountHolder& member = *(account->first);
         float balance = account->second;
         member.receiveStatement(date, balance);
      }
   }

}