
#include "Buyer.h"
#include <iostream>

namespace Example
{
   Buyer::Buyer(const string& name, const string& address, AuctionHouse& auctioneer, const string& username)
      : AccountHolder(name, address)
      , AuctionBrowser(username, auctioneer)
   {
   }

   Buyer::~Buyer()
   {
   }

   void Buyer::lookAt(Seller& vendor, const string& what, float cost)
   {
      if (login())
      {
         // make sure we have enough money to buy it now!
         if (getBalance() >= cost)
         {
            withdraw(cost);
            vendor.sell(*this, what, cost);
         }
         else
         {
            cout << "I can't even afford a crummy " << what << "!" << endl;
         }
      }
   }

}
